<?php
if(!defined('ABSPATH')) { exit; }
	/*
	Plugin Name: WP Spell Check
	Description: The Fastest Proofreading plugin that allows you to find & fix Spelling errors, Grammar errors, Broken HTML & Shortcodes and, SEO Opportunities to Create a professional image and take your site to the next level
	Version: 9.1
	Author: WP Spell Check
	Requires at least: 4.1.1
	Tested up to: 5.8
	Stable tag: 9.1
	License: GPLv2 or later
	License URI: http://www.gnu.org/licenses/gpl-2.0.html
	Copyright: © 2021 WP Spell Check
	Contributors: wpspellcheck
	Donate Link: www.wpspellcheck.com
	Donate Link: www.wpspellcheck.com
	Tags: spelling, SEO, Spell Check, WordPress spell check, Spell Checker, WordPress spell checker, spelling errors, spelling mistakes, spelling report, fix spelling, WP Spell Check
	
	Author URI: https://www.wpspellcheck.com
	
	Works in the background: yes
	Pro version scans the entire website: yes
	Sends email reminders: yes
	Finds place holder text: yes
	Custom Dictionary for unusual words: yes
	Scans Password Protected membership Sites: yes
	Unlimited scans on my website: Yes

	Scans Categories: Yes WP Spell Check Pro
	Scans SEO Titles: Yes WP Spell Check Pro
	Scans SEO Descriptions: Yes WP Spell Check Pro
	Scans WordPress Menus: Yes WP Spell Check Pro
	Scans Page Titles: Yes WP Spell Check Pro
	Scans Post Titles: Yes WP Spell Check Pro
	Scans Page slugs: Yes WP Spell Check Pro
	Scans Post Slugs: Yes WP Spell Check Pro
	Scans Post categories: Yes WP Spell Check Pro

	Privacy URI: https://www.wpspellcheck.com/privacy-policy/
	Pro Add-on / Home Page: https://www.wpspellcheck.com/
	Pro Add-on / Prices: https://www.wpspellcheck.com/pricing/
	*/

        require_once( ABSPATH . 'wp-admin/includes/upgrade.php' );
        require_once('admin/wpsc-class-database.php');
        register_activation_hook( __FILE__, array ('wpscx_database','wpsc_install_spellcheck_main' ));
        
        function wpscx_error_reporting() {
            $error = error_get_last();
            
            if (strpos($error['message'], "/wp-spell-check/") !== false || strpos($error['message'], "/wp-spell-check-pro/") !== false) {
                global $wpdb;
                global $ent_included;
                global $wpscx_title;
                $rng_seed = rand(0,999999999);
                $options_table = $wpdb->prefix . "spellcheck_options";
                $grammar_table = $wpdb->prefix . 'spellcheck_grammar_options';
                $ignore_table = $wpdb->prefix . 'spellcheck_ignore';
                $error_table = $wpdb->prefix . 'spellcheck_errors';
                $message = $error['message'];
                
                $wpdb->update($options_table, array('option_value' => 'PHP Crash'), array('option_name' => 'last_php_error'));
                $wpdb->insert($error_table, array('error_name' => $message)); 
                $settings = $wpdb->get_results('SELECT option_name, option_value FROM ' . $options_table);
                $grammar_settings = $wpdb->get_results('SELECT option_name, option_value FROM ' . $grammar_table);
                $last_scan = $settings[45]->option_value;
                
                if (isset($wpscx_title) && $wpscx_title != null) $wpdb->insert($ignore_table, array('keyword' => $wpscx_title, 'type' => 'page')); 
                
                $error_count = $wpdb->get_results("SELECT * FROM $error_table");
                
                $scan_in_progress = false;
		
		if ($settings[66]->option_value == 'true') $scan_in_progress = true;
		if ($settings[67]->option_value == 'true') $scan_in_progress = true;
		if ($settings[68]->option_value == 'true') $scan_in_progress = true;
		if ($settings[69]->option_value == 'true') $scan_in_progress = true;
		if ($settings[70]->option_value == 'true') $scan_in_progress = true;
		if ($settings[71]->option_value == 'true') $scan_in_progress = true;
		if ($settings[72]->option_value == 'true') $scan_in_progress = true;
		if ($settings[73]->option_value == 'true') $scan_in_progress = true;
		if ($settings[74]->option_value == 'true') $scan_in_progress = true;
		if ($settings[75]->option_value == 'true') $scan_in_progress = true;
		if ($settings[76]->option_value == 'true') $scan_in_progress = true;
		if ($settings[77]->option_value == 'true') $scan_in_progress = true;
		if ($settings[78]->option_value == 'true') $scan_in_progress = true;
		if ($settings[79]->option_value == 'true') $scan_in_progress = true;
		if ($settings[80]->option_value == 'true') $scan_in_progress = true;
		if ($settings[81]->option_value == 'true') $scan_in_progress = true;
		if ($settings[82]->option_value == 'true') $scan_in_progress = true;
		if ($settings[83]->option_value == 'true') $scan_in_progress = true;
		if ($settings[84]->option_value == 'true') $scan_in_progress = true;
		if ($settings[85]->option_value == 'true') $scan_in_progress = true;
                if ($settings[87]->option_value == 'true') $scan_in_progress = true;
                if ($settings[88]->option_value == 'true') $scan_in_progress = true;
                if ($settings[89]->option_value == 'true') $scan_in_progress = true;
                if ($settings[90]->option_value == 'true') $scan_in_progress = true;
                if ($settings[91]->option_value == 'true') $scan_in_progress = true;
                if ($settings[92]->option_value == 'true') $scan_in_progress = true;
                if ($settings[93]->option_value == 'true') $scan_in_progress = true;
                if ($settings[94]->option_value == 'true') $scan_in_progress = true;
                if ($settings[95]->option_value == 'true') $scan_in_progress = true;
                if ($settings[96]->option_value == 'true') $scan_in_progress = true;
                if ($settings[97]->option_value == 'true') $scan_in_progress = true;
                if ($settings[98]->option_value == 'true') $scan_in_progress = true;
                if ($settings[141]->option_value == "true") $scan_in_progress = true;
                if ($grammar_settings[8]->option_value == "true") $scan_in_progress = true;
                if ($grammar_settings[9]->option_value == "true") $scan_in_progress = true;
                
                if ($scan_in_progress) {
                    if ($last_scan == "Page Content") {
                        if ($ent_included) { 
                            wpscx_check_pages_ent();
                        } else {
                            wpscx_check_pages();
                        }
                    } elseif ($last_scan == "Post Content") {
                        if ($ent_included) { 
                            wpscx_check_posts_ent();
                        } else {
                            wpscx_check_pages();
                        }
                    } elseif ($last_scan == "Authors") {
                        wpscx_check_authors();
                    } elseif ($last_scan == "Menus") {
                        if ($ent_included) { 
                            wpscx_check_menus_ent();
                        } else {
                            wpscx_check_menus();
                        }
                    } elseif ($last_scan == "Tag Titles") {
                        wpscx_check_post_tags_ent();
                    } elseif ($last_scan == "Category Titles") {
                        wpscx_check_post_categories_ent();
                    } elseif ($last_scan == "SEO Descriptions") {
                        wpscx_check_yoast_ent();
                    } elseif ($last_scan == "SEO Titles") {
                        wpscx_check_seo_titles_ent();
                    } elseif ($last_scan == "Sliders") {
                        wpscx_check_sliders_ent();
                    } elseif ($last_scan == "Media Files") {
                        if ($ent_included) { 
                            wpscx_check_media_ent();
                        }
                    } elseif ($last_scan == "eCommerce Products") {
                        wpscx_check_ecommerce_ent();
                    } elseif ($last_scan == "Widgets") {
                        wpscx_check_widgets();
                    } elseif ($last_scan == "Contact Form 7") {
                        wpscx_check_cf7();
                    } elseif ($last_scan == "Entire Site") {
                        wpscx_scan_site_event(10, true);
                    }
                } else {
                    $wpsc_user_id = get_current_user_id();
                    
                    add_user_meta($wpsc_user_id,'wpsc_safe_mode','true',true);
                    add_user_meta($wpsc_user_id,'wpsc_error_msg',$message,true);
                    require_once dirname(__FILE__) . "/admin/reload.php";
                    exit();
                }
            }
        }
        register_shutdown_function('wpscx_error_reporting');
        
        function wpscx_core() {
            $wpsc_user_id = get_current_user_id();
            $safe_check = get_user_meta($wpsc_user_id, 'wpsc_safe_mode',true);
            
            if ($safe_check == 'true') {
                add_action('admin_head','wpsc_safe_mode');
            } else {
                $database = new wpscx_database;
                $database->wpsc_update_db_check_main();
                wpscx_load_plugin();
            }
        }
        add_action('init', 'wpscx_core');
        
        function wpsc_safe_mode() {
            global $wp_version;
            $wpsc_user_id = get_current_user_id();
            global $ent_included;
            
            $error = get_user_meta($wpsc_user_id, 'wpsc_error_msg',true);
            
            ?>
                <style>
                    #wpsc-error-report  { display: block; width: 330px; height: 165px; position: fixed; left: calc(50% - 150px); top: calc(50% - 150px); border: 2px solid black; border-radius: 15px; background: white; z-index: 999999; padding: 15px; }
                    #wpsc-error-confirm { display: block; width: 330px; height: 200px; position: fixed; left: calc(50% - 150px); top: calc(50% - 150px); border: 2px solid black; border-radius: 15px; background: white; z-index: 999999; padding: 15px; }
                    #wpsc-error-report button, #wpsc-error-confirm .wpsc-error-confirm-contact { text-decoration: none; background: #008200; color: white; padding: 5px 20px; border-radius: 15px; position: absolute; bottom: 10px; }
                    #wpsc-error-report a, #wpsc-error-confirm .wpsc-error-confirm-dismiss { text-decoration: none; color: grey; padding: 5px 20px; position: absolute; bottom: 10px; }
                </style>
                <script type='text/javascript'>
                    jQuery(document).ready(function() {
                        var wpsc_popup = jQuery('#wpsc-error-report');
                        var wpsc_form = wpsc_popup.find('form');
                        wpsc_form.submit(function(event) { 
                            event.preventDefault();

                            var form_data = {
                                    error: <?php echo json_encode(utf8_encode($error)); ?>,
                                    site: '<?php echo esc_url( home_url() ); ?>',
                                    wordpress_ver: '<?php echo $wp_version; ?>',
                                    php_ver: '<?php echo phpversion(); ?>',
                                    theme_name: '<?php echo wp_get_theme()->name; ?>',
                                    parent_name: '<?php echo wp_get_theme()->parent()->name; ?>',
                                    plugin_ver: '<?php echo '9.1' ?>'
                            };

                            var submit = jQuery.post('https://www.wpspellcheck.com/api/error-report.php', form_data);
                            submit.always(function() {
                                    location.href = '<?php echo html_entity_decode( esc_url( add_query_arg( array( 'wpsc_dismiss_error' => '1' ) ) ) ); ?>';
                            });
                        });
                    });
                </script>
                <div id="wpsc-error-report">
                    <form class="wpsc_error_form">
                        <h3 style='text-align: center;'>Ooops!</h3>
                        <p style='text-align: center;'>An error has occurred with WP Spell Check. Click on the Green button below to send us the error report so we can fix it.<br>Thank you.</p>
                        <button type="submit" class="wpsc-error-report-send" href="<?php echo html_entity_decode( esc_url( add_query_arg( array( 'wpsc_dismiss_error' => '1' ) ) ) ); ?>" style="left: 10px;">Send Report</button>
                        <a class="wpsc-error-report-dismiss" href="<?php echo html_entity_decode( esc_url( add_query_arg( array( 'wpsc_dismiss_error' => '2' ) ) ) ); ?>" style="right: 10px;">Dismiss</a>
                    </form>
                </div>
            <?php
            delete_user_meta($wpsc_user_id, 'wpsc_safe_mode');
            delete_user_meta($wpsc_user_id, 'wpsc_error_msg');
            deactivate_plugins( 'wp-spell-check/wpspellcheck.php' );
            deactivate_plugins( 'wp-spell-check-pro/wpspellcheckpro.php' );
        }

        function wpscx_load_plugin() {
            if (!(current_user_can( 'administrator' ) || current_user_can( 'editor' ) || current_user_can( 'author' ) || current_user_can( 'contributor' ))) {
                require_once( ABSPATH . 'wp-admin/includes/plugin.php' );
                require_once( ABSPATH . 'wp-includes/pluggable.php' );
                require_once( ABSPATH . 'wp-admin/includes/upgrade.php' );
                require_once( ABSPATH . 'wp-admin/includes/class-wp-list-table.php' );

                require_once( 'admin/wpsc-framework.php' );
                require_once('admin/wpsc-class-scanner.php');
                require_once ('admin/wpsc-class-email.php');
                require_once( 'admin/wpsc-empty.php' );
                require_once( 'admin/grammar/grammar_framework.php' );
                require_once('admin/grammar/wpsc-class-grammar.php');
                require_once('admin/wpsc-class-spellcheck.php');
                require_once('admin/wpsc-class-seo.php');
                
                if (is_plugin_active('wp-spell-check-pro/wpspellcheckpro.php')) {
                    $pro_data = get_plugin_data(dirname(__FILE__) . '-pro/wpspellcheckpro.php');
                    $pro_ver = $pro_data['Version'];
                    if (version_compare($pro_ver, '9.1') == 0) {
                                include dirname(__FILE__) . '-pro/pro-loader.php';
                    }
                }
                return;
            }

            require_once('admin/wpsc-class-admin.php');
            $wpscx = new wpscx_admin;

            if (is_plugin_active('wp-spell-check-pro/wpspellcheckpro.php')) {
                $pro_data = get_plugin_data(dirname(__FILE__) . '-pro/wpspellcheckpro.php');
                $pro_ver = $pro_data['Version'];
                if (version_compare($pro_ver, '9.1') == 0) {
                            include dirname(__FILE__) . '-pro/pro-loader.php';
                }
            }
            if (current_user_can( 'administrator' ) || current_user_can( 'editor' ) || current_user_can( 'author' ) || current_user_can( 'contributor' )) wp_enqueue_style( 'global-admin-styles', plugin_dir_url( __FILE__ ) . 'css/global-admin-styles.css' );
            if (get_option('wpsc_data_acti') == '' && current_user_can( 'administrator' ) && $_POST['uninstall'] != 'Clean up Database and Deactivate Plugin' && $_GET['action'] != 'activate' && $_GET['plugin_status'] == 'all') {
                add_action('admin_head', array('wpscx_banner','show_install_notice'));
               update_option('wpsc_data_acti',array());
            }
            
            if ( is_admin() ) {
		new wpscx_deactivation();
            }
            
            //Sample errors for testing safe mode - Call to Undfined Function and Call to Function on Null
            //test_function_error();
            //$test = null;
            //$test->get_id();
        }
	
	function wpscx_set_global_vars() {
		global $wpdb;
		global $ignore_list;
		global $dict_list;
		global $wpsc_settings;
		global $wpgc_settings;
		global $check_opt;
		global $wpsc_haystack;
		global $base_page_max;
		global $ent_included;
                global $wpsc_version;
                
                $wpsc_version = "9.1";
		
		$ignore_list = array();
		$dict_list = array();
		$wpgc_settings = array();
		
		$test_var = "Test successful";
		
		$words_table = $wpdb->prefix . 'spellcheck_words';
		$options_table = $wpdb->prefix . 'spellcheck_options';
		$grammar_options_table = $wpdb->prefix . 'spellcheck_grammar_options';
		$ignore_table = $wpdb->prefix . 'spellcheck_ignore';
		$dict_table = $wpdb->prefix . 'spellcheck_dictionary';
		
		$check_opt = $wpdb->get_results("SHOW TABLES LIKE '$options_table'");
		$check_word = $wpdb->get_results("SHOW TABLES LIKE '$words_table'");
		$check_ig = $wpdb->get_results("SHOW TABLES LIKE '$ignore_table'");
		$check_dict = $wpdb->get_results("SHOW TABLES LIKE '$dict_table'");
		$check_grm = $wpdb->get_results("SHOW TABLES LIKE '$grammar_options_table'");
		
		if (!isset($wpsc_settings) && sizeof($check_opt) != 0) {
			$wpsc_settings_temp = $wpdb->get_results("SELECT * FROM $options_table");
                        if (isset($wpsc_settings_temp) && sizeof($wpsc_settings_temp) > 0) {
                            $wpsc_settings = new SplFixedArray(sizeof($wpsc_settings_temp) + 1);
                            for ($x = 0; $x < sizeof($wpsc_settings_temp); $x++) {
                                    $wpsc_settings[$x] = $wpsc_settings_temp[$x];
                            }
                            unset($wpsc_settings_temp);
                        }
		}
		
		if (sizeof((array)$wpsc_settings) < 1) {
		
		if (sizeof($check_opt) != 0 && sizeof($check_word) != 0 && sizeof($check_ig) != 0 && sizeof($check_dict) != 0) {
			$ignore_list = $wpdb->get_results("SELECT word FROM $words_table WHERE ignore_word = true");
			$dict_list = $wpdb->get_results("SELECT word FROM $dict_table");
			$wpgc_settings = $wpdb->get_results("SELECT * FROM $grammar_options_table");
		}
		}
		
		if ($ent_included) {
			if (isset($wpsc_settings[138])) $base_page_max = $wpsc_settings[138]->option_value;
		} else {
			$base_page_max = 25;
		}
                
                //Sample error for testing safe mode - Out of Index on Fixed Array
                //$wpsc_settings[999] = "Test Error";
	}
	
        global $scdb_version;
        global $scan_delay;
        $scan_delay = 0;
        $scdb_version = '1.0';
        wpscx_set_global_vars();
	
	/* Initialization Code */
         /*Create Network Page*/
        function wpscx_uninstall_page() {
                if ($_POST['uninstall'] == 'Uninstall') {
                        check_admin_referer('wpsc_network_uninstall');
                        global $wpdb;

                        if (function_exists('is_multisite') && is_multisite()) {
                                if ($networkwide) {
                                        $old_blog = $wpdb->blogid;


                                        $blogids = $wpdb->get_col("SELECT blog_ID FROM $wpdb->blogs");
                                        foreach ($blogids as $blog_id) {
                                                switch_to_blog($blog_id);
                                                prepare_uninstall();
                                        }
                                        switch_to_blog($old_blog);
                                }
                        }
                        prepare_uninstall();
                        deactivate_plugins( 'wp-spell-check/wpspellcheck.php' );
                        if ($pro_included) deactivate_plugins( 'wp-spell-check-pro/wpspellcheckpro.php' );
                        if ($ent_included) deactivate_plugins( 'wp-spell-check-enterprise/wpspellcheckenterprise.php' );
                        wp_die( 'WP Spell Check has been deactivated. If you wish to use the plugin again you may activate it on the WordPress plugin page' );
                }

                ?>
                <h2><img src="<?php echo plugin_dir_url( __FILE__ ) . 'images/logo.png'; ?>" alt="WP Spell Check" /> <span style="position: relative; top: -15px;">Network Uninstall</span></h2>
                <p>This will deactivate WP Spell Check on all sites on the network and clean up the database of any changes made by WP Spell Check. If you wish to use WP Spell Check again after, you may activate it on the WordPress plugins page</p>
                <form action="settings.php?page=wpsc_uninstall_page" method="post" name="uninstall">
                        <?php wp_nonce_field('wpsc_network_uninstall'); ?>
                        <input type="submit" name="uninstall" value="Clean up Database and Deactivate Plugin" />
                </form>
                <?php
        }
        
        function wpscx_cron_add_custom() {
        global $wpdb;
        wpscx_set_global_vars();
        global $check_opt;
        $table_name = $wpdb->prefix . 'spellcheck_options';
        $check_db = $check_opt;
        if(sizeof($check_db) != 0) {
                if (!isset($_POST['scan_frequency_interval']) && !isset($_POST['scan_frequency'])) {
                        $scan_frequency = $wpdb->get_results('SELECT option_value FROM ' . $table_name . ' WHERE option_name="scan_frequency";');
                        $scan_frequency_interval = $wpdb->get_results('SELECT option_value FROM ' . $table_name . ' WHERE				option_name="scan_frequency_interval";');
                        $scan_interval = $scan_frequency_interval[0]->option_value;
                        $scan_timer = intval($scan_frequency[0]->option_value);
                } else {
                        $scan_interval = $_POST['scan_frequency_interval'];
                        $scan_timer = intval($_POST['scan_frequency']);
                }

                switch($scan_interval) {
                        case "hourly":
                                $scan_recurrence = $scan_timer * 3600;
                                break;
                        case "daily":
                                $scan_recurrence = $scan_timer * 86400;
                                break;
                        case "weekly":
                                $scan_recurrence = $scan_timer * 604800;
                                break;
                        case "monthly":
                                $scan_recurrence = $scan_timer * 2592000;
                                break;
                        default:
                                $scan_recurrence = 604800;
                }

                //echo "Debug(wpsc) - " . $scan_recurrence . "<br>";
                $schedules['wpsc'] = array(
                        'interval' => $scan_recurrence,
                        'display' => __( 'wpsc' )
                );
        }
        return $schedules;
    }
    add_filter( 'cron_schedules', 'wpscx_cron_add_custom' );
?>